fw_filesystem.sh 3.1 KB
Newer Older
K
Kees Cook 已提交
1 2 3 4 5 6 7 8
#!/bin/sh
# This validates that the kernel will load firmware out of its list of
# firmware locations on disk. Since the user helper does similar work,
# we reset the custom load directory to a location the user helper doesn't
# know so we can be sure we're not accidentally testing the user helper.
set -e

DIR=/sys/devices/virtual/misc/test_firmware
9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25
TEST_DIR=$(dirname $0)

test_modprobe()
{
	if [ ! -d $DIR ]; then
		echo "$0: $DIR not present"
		echo "You must have the following enabled in your kernel:"
		cat $TEST_DIR/config
		exit 1
	fi
}

trap "test_modprobe" EXIT

if [ ! -d $DIR ]; then
	modprobe test_firmware
fi
K
Kees Cook 已提交
26

27 28 29 30 31 32 33 34 35
# CONFIG_FW_LOADER_USER_HELPER has a sysfs class under /sys/class/firmware/
# These days no one enables CONFIG_FW_LOADER_USER_HELPER so check for that
# as an indicator for CONFIG_FW_LOADER_USER_HELPER.
HAS_FW_LOADER_USER_HELPER=$(if [ -d /sys/class/firmware/ ]; then echo yes; else echo no; fi)

if [ "$HAS_FW_LOADER_USER_HELPER" = "yes" ]; then
	OLD_TIMEOUT=$(cat /sys/class/firmware/timeout)
fi

K
Kees Cook 已提交
36 37 38 39 40 41 42
OLD_FWPATH=$(cat /sys/module/firmware_class/parameters/path)

FWPATH=$(mktemp -d)
FW="$FWPATH/test-firmware.bin"

test_finish()
{
43 44 45
	if [ "$HAS_FW_LOADER_USER_HELPER" = "yes" ]; then
		echo "$OLD_TIMEOUT" >/sys/class/firmware/timeout
	fi
K
Kees Cook 已提交
46 47 48 49 50 51 52
	echo -n "$OLD_PATH" >/sys/module/firmware_class/parameters/path
	rm -f "$FW"
	rmdir "$FWPATH"
}

trap "test_finish" EXIT

53 54 55 56 57
if [ "$HAS_FW_LOADER_USER_HELPER" = "yes" ]; then
	# Turn down the timeout so failures don't take so long.
	echo 1 >/sys/class/firmware/timeout
fi

K
Kees Cook 已提交
58 59 60 61 62 63 64 65
# Set the kernel search path.
echo -n "$FWPATH" >/sys/module/firmware_class/parameters/path

# This is an unlikely real-world firmware content. :)
echo "ABCD0123" >"$FW"

NAME=$(basename "$FW")

66
if printf '\000' >"$DIR"/trigger_request 2> /dev/null; then
67 68 69 70
	echo "$0: empty filename should not succeed" >&2
	exit 1
fi

71
if printf '\000' >"$DIR"/trigger_async_request 2> /dev/null; then
72 73 74 75
	echo "$0: empty filename should not succeed (async)" >&2
	exit 1
fi

K
Kees Cook 已提交
76
# Request a firmware that doesn't exist, it should fail.
77
if echo -n "nope-$NAME" >"$DIR"/trigger_request 2> /dev/null; then
78 79 80
	echo "$0: firmware shouldn't have loaded" >&2
	exit 1
fi
K
Kees Cook 已提交
81 82 83 84
if diff -q "$FW" /dev/test_firmware >/dev/null ; then
	echo "$0: firmware was not expected to match" >&2
	exit 1
else
85 86 87
	if [ "$HAS_FW_LOADER_USER_HELPER" = "yes" ]; then
		echo "$0: timeout works"
	fi
K
Kees Cook 已提交
88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104
fi

# This should succeed via kernel load or will fail after 1 second after
# being handed over to the user helper, which won't find the fw either.
if ! echo -n "$NAME" >"$DIR"/trigger_request ; then
	echo "$0: could not trigger request" >&2
	exit 1
fi

# Verify the contents are what we expect.
if ! diff -q "$FW" /dev/test_firmware >/dev/null ; then
	echo "$0: firmware was not loaded" >&2
	exit 1
else
	echo "$0: filesystem loading works"
fi

105 106 107 108 109 110 111 112 113 114 115 116 117 118
# Try the asynchronous version too
if ! echo -n "$NAME" >"$DIR"/trigger_async_request ; then
	echo "$0: could not trigger async request" >&2
	exit 1
fi

# Verify the contents are what we expect.
if ! diff -q "$FW" /dev/test_firmware >/dev/null ; then
	echo "$0: firmware was not loaded (async)" >&2
	exit 1
else
	echo "$0: async filesystem loading works"
fi

K
Kees Cook 已提交
119
exit 0